#include <FASM.au3>

Global $___avOP[1], $___ASM_DLL_USER32, $___ASM_DLL_GDI32, $___oASM

; #FUNCTION# ====================================================================================================================
; Description ...: Fhrt einen OP-Code aus
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_Call($iOP, $iPtr)
	DllCall($___ASM_DLL_USER32, 'ptr', 'CallWindowProcW', 'ptr', DllStructGetPtr($___avOP[$iOP]), 'ptr', $iPtr, 'int', 0, 'int', 0, 'int', 0)
EndFunc

; #FUNCTION# ====================================================================================================================
; Description ...: Fgt OP-Codes zum Struct Array hinzu, $a vereinfacht das Hinzufgen via _ASM_Add_OP(_MyFunc())
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_AddOP($a = 0)
	Local $vOP = __ASM_GetStruct()
	Local $u = UBound($___avOP)
	ReDim $___avOP[$u+1]
	$___avOP[0] += 1
	$___avOP[$u] = $vOP
	Return $___avOP[0]
EndFunc
; #FUNCTION# ====================================================================================================================
; Description ...: Ld ntige DLLs und initialisiert alle OP-Codes fr die sptere Benutzung
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_Startup()
	$___oASM = FasmInit()
	FasmReset($___oASM)
	$___ASM_DLL_USER32 = DllOpen('USER32.DLL')
	$___ASM_DLL_GDI32 = DllOpen('GDI32.DLL')
EndFunc

; #FUNCTION# ====================================================================================================================
; Description ...: Gibt die Ressourcen wieder frei
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_Shutdown()
	FasmExit($___oASM)
	For $i = 1 To $___avOP[0] Step 1
		$___avOP[$i] = 0
	Next
	DllClose($___ASM_DLL_USER32)
EndFunc

; #FUNCTION# ====================================================================================================================
; Description ...: Creates an empty ImageStruct
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_CreateBitmap($iW, $iH)
	Local $hDC = DllCall($___ASM_DLL_GDI32, 'handle', 'CreateCompatibleDC', 'handle', 0)[0], $tBMI = DllStructCreate('struct' & _
	';dword Size;long Width;long Height;word Planes;word BitCount;dword Compression;dword SizeImage;long XPelsPerMeter;long ' & _
	'YPelsPerMeter;dword ClrUsed;dword ClrImportant;endstruct;dword RGBQuad'), $t = DllStructSetData($tBMI, 'Size', _
	DllStructGetSize($tBMI) - 4) + DllStructSetData($tBMI, 'Width', $iW) + DllStructSetData($tBMI, 'Height', - $iH) _
	+ DllStructSetData($tBMI, 'Planes', 1) + DllStructSetData($tBMI, 'BitCount', 32), $aDIB = DllCall($___ASM_DLL_GDI32, 'ptr', _
	'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 0, 'ptr*', 0, 'ptr', 0, 'uint', 0), $t = _
	DllCall($___ASM_DLL_GDI32, 'handle', 'SelectObject', 'handle', $hDC, 'handle', $aDIB[0]), $vStr = DllStructCreate('int[5]') _
	, $t = DllStructSetData($vStr, 1, $hDC, 1) + DllStructSetData($vStr, 1, $iW, 2) + DllStructSetData($vStr, 1, $iH, 3) + _
	DllStructSetData($vStr, 1, $aDIB[4], 4) + DllStructSetData($vStr, 1, $aDIB[0], 5)
	Return $vStr
EndFunc   ;==>_Image_Create

; #FUNCTION# ====================================================================================================================
; Description ...: Deletes an ImageStruct
; Author ........: Mars
; ===============================================================================================================================
Func _ASM_DeleteBitmap(ByRef $vStruct)
	DllCall($___ASM_DLL_GDI32, 'bool', 'DeleteObject', 'handle', DllStructGetData($vStruct, 1, 5))
	DllCall($___ASM_DLL_GDI32, 'bool', 'DeleteDC', 'handle', DllStructGetData($vStruct, 1, 1))
	$vStruct = 0
EndFunc   ;==>_Image_Delete

; #FUNCTION# ====================================================================================================================
; Description ...: Wrapper fr FasmAdd (fr weniger Schreibarbeit)
; Author ........: Unknown
; ===============================================================================================================================
Func _($a) ; Fieser Diebstahl meinerseits. Wo diese komplexe Funktion ihren Ursprung hat bleibt ein Mysterium...
	FasmAdd($___oASM, $a)
EndFunc

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Description ...: Verpackt den in Fasm befindlichen Code in eine DllStruct die per CallWindowProc aufgerufen werden kann
; Author ........: Mars
; ===============================================================================================================================
Func __ASM_GetStruct()
	Local $vStruct = __ASM_ToStruct(FasmGetBinary($___oASM))
	If FasmGetLastError()[0] Then _FasmError()
	FasmReset($___oASM)
	Return $vStruct
EndFunc   ;==>_Get_ASM_Struct

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Description ...: Verpackt den im Parameter enthaltenen Code in eine DLLStruct
; Author ........: Mars
; ===============================================================================================================================
Func __ASM_ToStruct($ASM)
	Local $vStr = DllStructCreate('byte[' & StringLen($ASM) / 2 - 1 & ']')
	DllStructSetData($vStr, 1, $ASM)
	Return $vStr
EndFunc   ;==>_AsmToStruct