#include 'EasyASM.au3'
#include <WinAPI.au3>

Opt('GUIOnEventMode', 1)
_ASM_Startup()

; Haupteigenschaften des Programms
Global Const $sTitel = 'Test 01'	; Titel des Fensters
Global Const $iW = Int(@DesktopWidth/256)*128	; Breite des Fensters
Global Const $iH = Int(@DesktopHeight/2)				; Hhe des Fensters
Global Const $iMemSize = 64			; Reserviertes RAM in Bytes
Global Const $nFrameRate = 60		; Gewnschte Framerate (ob diese eingehalten wird hngt vom BitBlt, sowie vom ASM ab)

; Aufbau der bergebenen Daten:
; int[5]
; [0] - Ptr fr die Bitmapdaten
; [1] - Ptr fr das reservierte RAM
; [2] - Anzahl reservierte Bytes (damit man im ASM wei wie viel RAM man zur Verfgung hat)
; [3] - Breite der Anzeige | Die Anzahl Pixel errechnet man sich am
; [4] - Hhe der Anzeige   | besten selbst, so bleibt $vData kleiner ;)

Global $Memory = DllStructCreate('int[' & $iMemSize & ']')
Global $Image = _ASM_CreateBitmap($iW, $iH)
Global $hGUI = GUICreate($sTitel, $iW, $iH), $bExit = False
Global $nAuslastung, $iFPS, $nFPS, $iFPS_Timer = TimerInit()
Global $hDC = _WinAPI_GetDC($hGUI), $hDC_IMG = DllStructGetData($Image, 1, 1)
Global $ntDLL = DllOpen('ntdll.dll'), $vNano = DllStructCreate('int64 time'), $pNano = DllStructGetPtr($vNano)
Global $vData = DllStructCreate('int[5]'), $pData = DllStructGetPtr($vData)
Global $iMyASM = _ASM_AddOP(_MyASM())

DllStructSetData($vData, 1, DllStructGetData($Image, 1, 4), 1)	; Ptr auf die Bitmapdaten
DllStructSetData($vData, 1, DllStructGetPtr($Memory), 2)		; Ptr auf das reservierte RAM
DllStructSetData($vData, 1, $iMemSize, 3)						; Anzahl reservierte Bytes
DllStructSetData($vData, 1, $iW, 4)								; Breite der Anzeige
DllStructSetData($vData, 1, $iH, 5)								; Hhe der Anzeige

GUISetOnEvent(-3, '_Exit', $hGUI)
GUISetState(@SW_SHOW, $hGUI)

_Main()

; ===============================================================================================================================
; Hier den eigenen Code einfgen. Das Restliche Skript unberhrt lassen (auer man mchte es erweitern oder Fehler bekmpfen)
; ===============================================================================================================================
Func _MyASM()
	_('use32')

	; Beim Call sind die Adressen um 4 Byte verschoben,
	; spter, beim Zugriff auf unsere Struct um Ram oder
	; beim Zugriff auf die Bitmap ist das nicht mehr so !
	; Um zur ersten Struct zu kommen mssen wir [esp+4] nehmen,
	; hier liegt die ptr zu unserer DatenStruct

	_('mov eax, [esp+4]') ; Ptr auf die Datenstruct

	; Wir wissen wie die Struct aussieht:
	; ptrIMG|ptrMEM|anzahl|breite|hhe
	;   +0  |  +4  |  +8  | +12  | +16
	; Hier gibts keine Verschiebung mehr, nie wieder :)

	_('mov ebx, [eax+12]') ; Breite der Anzeige
	_('mov ecx, [eax+16]') ; Hhe der Anzeige
	_('imul ecx, ebx') ; Anzahl Pixel in ecx

	; Jetzt haben wir erstmal die Anzahl Pixel
	; Fehlt nur noch eine Position an der wir
	; wild herummalen knnen...

	_('mov esi, [eax]') ; Ptr der Anzeige in ebx

	; man knnte jetzt jedes freie Register nutzen,
	; wir nehmen einfach mal esi.
	; Damit wir das Bild frben knnen brauchen
	; wir noch eine Farbe die sich am besten
	; laufend verndert. Dazu springen wir in
	; unser bereitgestelltes RAM und benutzen die ersten 4 Byte. (0x FF FF FF FF = 4 Byte)

	_('mov edx, [eax+4]') ; Ptr unseres Rams
	_('mov ebx, [edx]') ; Unsere ersten 4 Bytes !
	_('add ebx, 1024') ; Wir erhhen die Farbe
	_('or ebx, 0xFF000000') ; Falls der Alphakanal flten geht (overflow)
	_('mov [edx], ebx') ; neue Farbe speichern

	; Jetzt nur noch Alle Pixel ablaufen und die
	; Farbe hineinmalen. (Dabei kann man sie natrlich
	; weiterhin nach belieben manupulieren). Zum Glck
	; haben wir ptrIMG sowie die Anzahl Pixel bereits in esi und ecx

	_('_Label_01:') ; Sprungstelle mit kreativem Namen
	_('add ebx, 512') ; Weil es so schn war :)
	_('or ebx, 0xFF200080') ; bischl
	_('mov [esi], ebx') ; Die Farbe in die Bitmap schreiben

	_('add esi, 4') ; 1PX = 4Byte weiterrcken
	_('dec ecx') ; Verbleibende Pixel = einer weniger als vorher (dec = decrement -> ecx -=1)
	_('ja _Label_01') ; Solange ecx > 0 springen wir zur Sprungstelle (ja = jump above)
	_('')
	_('')
	_('')
	_('ret') ; Braucht keine Sau :O

EndFunc

; ===============================================================================================================================
; Hauptschleife inklusive Datenfreigabe
; ===============================================================================================================================
Func _Main()
	While Not $bExit
		_ASM_Call($iMyASM, $pData)
		$nAuslastung = _Sleep()
		_WinAPI_BitBlt($hDC, 0, 0, $iW, $iH, $hDC_IMG, 0, 0, 0xCC0020)
		$iFPS += 1
		If TimerDiff($iFPS_Timer) > 1000 Then
			$iFPS_Timer = TimerInit()
			$nFPS = $iFPS
			$iFPS = 0
			WinSetTitle($hGUI, '', $sTitel & ' - (@' & $nFPS & 'FPS | Load:' & Round(100 * $nAuslastung) & '%)')
		EndIf
	WEnd
	_Release()
EndFunc

; ===============================================================================================================================
; Funktion um eine Schleife mit einer gewissen Geschwindigkeit
; durchlaufen zu lassen. Es wird zwar nanosleep benutzt, aber
; es gibt keine Garantie, dass dieser funktioniert wie gewollt.
; ===============================================================================================================================
Func _Sleep()
	Local Static $_t = TimerInit(), $f, $TT
	Local $s = TimerDiff($_t), $l = (1000 / $nFrameRate - $s)
	$f += $l
	If $f < 0 Then $f = 0
	If $l < 0 Then $l = 0
	$TT = TimerInit()
	DllStructSetData($vNano, 'time', -10000 * $f)
    DllCall($ntDLL, 'dword', 'ZwDelayExecution', 'int', 0, 'ptr', $pNano)
	$f -= TimerDiff($TT)
	$_t = TimerInit()
	Return $s / ($s + $l)
EndFunc

; ===============================================================================================================================
; Die eigentliche Funktion um alle benutzten Ressourcen freizugeben.
; ===============================================================================================================================
Func _Release()
	_WinAPI_ReleaseDC($hGUI, $hDC)
	$_Memory = 0
	_ASM_DeleteBitmap($Image)
	_ASM_Shutdown()
	DllClose($ntDLL)
EndFunc

; ===============================================================================================================================
; Da man mittem im ASM nicht unbedingt aus dem Skript gehen sollte,
; gibt es eine Variable die ein beenden der Hauptschleife verursacht.
; Der laufende ASM Code wird also nicht unterbrochen.
; ===============================================================================================================================
Func _Exit()
	$bExit = True
EndFunc